package com.itcast.test.classss.ioencrypt;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

/**
 * 思路
 * 毕老师讲的一个规律  ：同一个数 按位异或(^) 同样一个数，结果还是这个数
 * 例如
 * (a^b)^b =a 
 * 
 * 而a^b相当于加密过程
 * (a^b)^b相当于解密过程
 * @author Administrator
 *
 */
public class EncryptGen {
	//密码的默认值
	private static String key = "abc@#$%efg^&*(alsdjflaksdjfiewn)";
	private  static byte[] KEYVALUE = null;
	// 缓存大小
	static final int BUFFERLEN = 1024;

	public static void main(String[] args) {
//		String sourFile ="E:\\test\\user.txt" , targetFile ="E:\\test\\user_encrypt.txt";
//		String sourFilePath ="E:\\test\\testEncrypt" , targetFilePath ="E:\\test\\temp";
		String sourFilePath ="E:\\test\\temp" , targetFilePath ="E:\\test\\RES";
		key = "123456789";
		
		File sourFile = new File(sourFilePath);///源文件
		File targetFile = new File(targetFilePath);//目标文件
		//判断如果是  目录，就把目录里面的文件全部加密
		if(sourFile.isDirectory()){
			if(!targetFile.exists()){
				targetFile.mkdirs();
			}
			File [] files = sourFile.listFiles();
			for(File f : files){
				String fileName = f.getName();
				File destFile = new File(targetFilePath+File.separator+fileName);
				encryptFile(f,destFile);
			}
		}else if(sourFile.isFile()){///如果传进来的是一个文件 ，就把这个文件加密
			File tmp = new File(targetFilePath);
			if(tmp.isFile()){
				encryptFile(sourFilePath,targetFilePath);
			}else{System.out.println("目标文件有问题");}
		}
		
	}

	/**
	 * 具体加密、解密的方法
	 * @param sourceFile
	 * @param targetFile
	 */
	public static void encryptFile(File sourceFile, File targetFile) {
		KEYVALUE = key.getBytes();
		FileInputStream fis = null;
		FileOutputStream fos = null;
		try {
			fis = new FileInputStream(sourceFile);
			if (!targetFile.exists()) {
				targetFile.createNewFile();
			}
			fos = new FileOutputStream(targetFile);
			int c, pos = 0, keylen = KEYVALUE.length;
			byte[] buf = new byte[BUFFERLEN];
			while ((c = fis.read(buf)) != -1) {
				for (int i = 0; i < c; i++) {
					buf[i] ^= KEYVALUE[pos++];
					fos.write(buf[i]);
					if (pos == keylen) {pos = 0;}
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("找不到文件" + e.getMessage());
		} catch (IOException e) {
			System.out.println("IO异常" + e.getMessage());
		} finally {
			try {
				if (fis != null)fis.close();
				if (fos != null)fos.close();
			} catch (IOException e) {
				System.out.println("关闭 文件流出现异常" + e.getMessage());
			}
		}
	}
	
	
	/**
	 * 既可以是加密方法  ，也可以做为解密方法
	 * @param sourceFile
	 * @param targetFile
	 */
	public static void encryptFile(String sourceFile, String targetFile) {
		encryptFile(new File(sourceFile),new File(targetFile));
	}
}
